Loading...
Searching...
No Matches
Sip_separator

## Macros

#define | sip_separator(sip)
| Access a SIP separator line between headers and body structure sip_separator_t from sip_t.
#define | SIP_SEPARATOR_INIT()
| Initializer for structure sip_separator_t.
#define | SIPTAG_SEPARATOR(x)
| Tag list item for pointer to a separator line between headers and body structure sip_separator_t.
#define | SIPTAG_SEPARATOR_REF(x)
| Tag list item for reference to a separator line between headers and body pointer.
#define | SIPTAG_SEPARATOR_STR(s)
| Tag list item for string with separator line between headers and body value.
#define | SIPTAG_SEPARATOR_STR_REF(x)
| Tag list item for reference to a separator line between headers and body string.

## Typedefs

typedef msg_separator_t | sip_separator_t
| @

## Functions

issize_t | sip_separator_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP separator line between headers and body.
issize_t | sip_separator_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP separator line between headers and body.
sip_separator_t * | sip_separator_init (sip_separator_t x[1])
| Initialize a structure sip_separator_t.
int | sip_is_separator (sip_header_t const *header)
| Test if header object is instance of sip_separator_t.
sip_separator_t * | sip_separator_dup (su_home_t *home, sip_separator_t const *hdr))
| Duplicate a list of separator line between headers and body header structures sip_separator_t.
sip_separator_t * | sip_separator_copy (su_home_t *home, sip_separator_t const *hdr))
| Copy a list of separator line between headers and body header structures sip_separator_t.
sip_separator_t * | sip_separator_make (su_home_t *home, char const *s))
| Make a separator line between headers and body structure sip_separator_t.
sip_separator_t * | sip_separator_format (su_home_t *home, char const *fmt,...)))
| Make a separator line between headers and body from formatting result.
sip_separator_t * | sip_separator_create (su_home_t *home)
| Create a SIP separator line structure.

## Variables

msg_hclass_t | sip_separator_class []
| Header class for separator line between headers and body.
tag_typedef_t | siptag_separator
| Tag for separator line between headers and body object.
tag_typedef_t | siptag_separator_str
| Tag for string with separator line between headers and body value.

## Detailed Description

## Macro Definition Documentation

## SIP_SEPARATOR_INIT

#define SIP_SEPARATOR_INIT | ( |  | ) |

Initializer for structure sip_separator_t.

A static sip_separator_t structure for separator line between headers and body must be initialized with the SIP_SEPARATOR_INIT() macro. For instance,

sip_separator_t sip_separator = SIP_SEPARATOR_INIT;
sip_separator_t
msg_separator_t sip_separator_t
@
Definition sip.h:136
SIP_SEPARATOR_INIT
#define SIP_SEPARATOR_INIT()
Initializer for structure sip_separator_t.
Definition sip_protos.h:16570
sip_separator
#define sip_separator(sip)
Access a SIP separator line between headers and body structure sip_separator_t from sip_t.
Definition sip_protos.h:16553

## SIPTAG_SEPARATOR

#define SIPTAG_SEPARATOR | ( |  | x | ) |

Tag list item for pointer to a separator line between headers and body structure sip_separator_t.

The SIPTAG_SEPARATOR() macro is used to include a tag item with a pointer to a sip_separator_t structure in a tag list.

Parameters

  x | pointer to a sip_separator_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_SEPARATOR_REF().

## SIPTAG_SEPARATOR_STR

#define SIPTAG_SEPARATOR_STR | ( |  | s | ) |

Tag list item for string with separator line between headers and body value.

The SIPTAG_SEPARATOR_STR() macro is used to include a tag item with a string containing value of a sip_separator_t header in a tag list.

Parameters

  s | pointer to a string containing separator line between headers and body value, or NULL.

The string in SIPTAG_SEPARATOR_STR() can be converted to a sip_separator_t header structure by giving the string s has second argument to function sip_separator_make().

The corresponding tag taking reference parameter is SIPTAG_SEPARATOR_STR_REF().

## Typedef Documentation

## sip_separator_t

typedef msg_separator_t sip_separator_t

@

An empty line separates message headers from the message body (payload). In order to avoid modifying messages with integrity protection, the separator line has its own header structure which is included in the sip_t structure.

The parsed separator line is stored in sip_separator_t structure.

The structure sip_separator_t contains representation of separator line between message headers and body.

The sip_separator_t is defined as follows:

typedef struct sip_separator_s {
msg_common_t sep_common[1]; // Common fragment info
msg_header_t *sep_next; // Pointer to next header
char sep_data[4]; // NUL-terminated separator
} sip_separator_t;
msg_header_t
MSG_HDR_T msg_header_t
msg_common_t
struct msg_common_s msg_common_t

## Function Documentation

## sip_is_separator()

int sip_is_separator | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_separator_t.

Check if the header class is an instance of separator line between headers and body object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header separator
  0 | (false) otherwise

## sip_separator_copy()

sip_separator_t * sip_separator_copy | ( | su_home_t * | home,
|  | sip_separator_t const * | hdr )

inline

Copy a list of separator line between headers and body header structures sip_separator_t.

The function sip_separator_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  separator = sip_separator_copy(home, sip->sip_separator);
  sip_separator_copy
  sip_separator_t * sip_separator_copy(su_home_t *home, sip_separator_t const *hdr))
  Copy a list of separator line between headers and body header structures sip_separator_t.
  Definition sip_protos.h:16700

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_separator_create()

sip_separator_t * sip_separator_create | ( | su_home_t * | home | ) |

Create a SIP separator line structure.

Create a SIP separator line structure.

## sip_separator_dup()

sip_separator_t * sip_separator_dup | ( | su_home_t * | home,
|  | sip_separator_t const * | hdr )

inline

Duplicate a list of separator line between headers and body header structures sip_separator_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  separator = sip_separator_dup(home, sip->sip_separator);
  sip_separator_dup
  sip_separator_t * sip_separator_dup(su_home_t *home, sip_separator_t const *hdr))
  Duplicate a list of separator line between headers and body header structures sip_separator_t.
  Definition sip_protos.h:16657

Returns
  A pointer to the newly duplicated sip_separator_t header structure, or NULL upon an error.

## sip_separator_format()

sip_separator_t * sip_separator_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a separator line between headers and body from formatting result.

Make a new sip_separator_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_separator_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_separator_init()

sip_separator_t * sip_separator_init | ( | sip_separator_t | x[1] | ) |

inline

Initialize a structure sip_separator_t.

An sip_separator_t structure for separator line between headers and body can be initialized with the sip_separator_init() function/macro. For instance,

sip_separator_t sip_separator;
sip_separator_init(&sip_separator);
sip_separator_init
sip_separator_t * sip_separator_init(sip_separator_t x[1])
Initialize a structure sip_separator_t.
Definition sip_protos.h:16588

## sip_separator_make()

sip_separator_t * sip_separator_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a separator line between headers and body structure sip_separator_t.

The function sip_separator_make() makes a new sip_separator_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_separator_t header structure, or NULL upon an error.

## Variable Documentation

## sip_separator_class

msg_hclass_t sip_separator_class[]

extern

Header class for separator line between headers and body.

The header class sip_separator_class defines how a SIP separator line between headers and body is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_separator_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.